package com.ruoyi.system.service.impl;

import java.lang.reflect.InvocationTargetException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;

import com.ruoyi.common.core.domain.entity.SysUser;
import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.common.utils.SecurityUtils;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.system.domain.*;
import com.ruoyi.system.mapper.ActSuppliesCleaningRuleMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.ruoyi.system.mapper.ActSuppliesHistorydataMapper;
import com.ruoyi.system.service.IActSuppliesHistorydataService;
import org.springframework.transaction.annotation.EnableTransactionManagement;
import org.springframework.transaction.annotation.Transactional;

/**
 *  历史数据Service业务层处理
 *
 * @author dongjg
 * @date 2023-08-01
 */
@Service
@EnableTransactionManagement
public class ActSuppliesHistorydataServiceImpl implements IActSuppliesHistorydataService
{
    @Autowired
    private ActSuppliesHistorydataMapper actSuppliesHistorydataMapper;

    @Autowired
    private ActSuppliesCleaningRuleMapper actSuppliesCleaningRuleMapper;

    /**
     * 查询 历史数据
     *
     * @param id  历史数据ID
     * @return  历史数据
     */
    @Override
    public ActSuppliesHistorydata selectActSuppliesHistorydataById(Long id)
    {
        return actSuppliesHistorydataMapper.selectActSuppliesHistorydataById(id);
    }

    /**
     * 查询 历史数据列表
     *
     * @param actSuppliesHistorydata  历史数据
     * @return  历史数据
     */
    @Override
    public List<ActSuppliesHistorydata> selectActSuppliesHistorydataList(ActSuppliesHistorydata actSuppliesHistorydata)
    {
        SysUser user = SecurityUtils.getLoginUser().getUser();
      actSuppliesHistorydata.setCreateBy(user.getUserName());
        return actSuppliesHistorydataMapper.selectActSuppliesHistorydataList(actSuppliesHistorydata);
    }

    /**
     * 新增 历史数据
     *
     * @param actSuppliesHistorydata  历史数据
     * @return 结果
     */
    @Override
    public int insertActSuppliesHistorydata(List<ActSuppliesHistorydata> actSuppliesHistorydata)
    {

        for (int i=0;i<actSuppliesHistorydata.size();i++){

            Long status = actSuppliesHistorydata.get(i).getStatus();

        }
        return actSuppliesHistorydataMapper.insertActSuppliesHistorydata(actSuppliesHistorydata.get(0));
    }

    /**
     * 修改 历史数据
     *
     * @param actSuppliesHistorydata  历史数据
     * @return 结果
     */
    @Override
    public int updateActSuppliesHistorydata(ActSuppliesHistorydata actSuppliesHistorydata)
    {
        return actSuppliesHistorydataMapper.updateActSuppliesHistorydata(actSuppliesHistorydata);
    }

    /**
     * 批量删除 历史数据
     *
     * @param ids 需要删除的 历史数据ID
     * @return 结果
     */
    @Override
    public int deleteActSuppliesHistorydataByIds(Long[] ids)
    {
        return actSuppliesHistorydataMapper.deleteActSuppliesHistorydataByIds(ids);
    }

    /**
     * 删除 历史数据信息
     *
     * @param id  历史数据ID
     * @return 结果
     */
    @Override
    public int deleteActSuppliesHistorydataById(Long id)
    {
        return actSuppliesHistorydataMapper.deleteActSuppliesHistorydataById(id);
    }

    @Override
    public int addInsertActSuppliesHistorydata(List<ActSuppliesHistorydata> actSuppliesHistorydata) {

        SysUser user = SecurityUtils.getLoginUser().getUser();
        ActSuppliesHistorydata actSuppliesHistorydata1 = new ActSuppliesHistorydata();

        List<ActSuppliesHistorydata> s = actSuppliesHistorydataMapper.selectActSuppliesHistorydatauuid(actSuppliesHistorydata.get(0).getImportUuid());

        if (s.size()>0){
            if (s.get(0).getCleanStatus()>0){

                for (int j=0;j<s.size();j++){
                    if (s.get(j).getIdentifyingCode()==0){
                        actSuppliesCleaningRuleMapper.deleteActSuppliesImportTable(s.get(j).getId());
                    }else if (s.get(j).getIdentifyingCode()==1){
                        actSuppliesCleaningRuleMapper.deleteActSuppliesSixMinesSummaryTable(s.get(j).getId());
                    }
                }

            }
            for (int i=0;i<actSuppliesHistorydata.size();i++) {

                actSuppliesHistorydata.get(i).setCreateBy(user.getUserName());
                actSuppliesHistorydata.get(i).setCreateTime(DateUtils.getNowDate());
                actSuppliesHistorydataMapper.updateActSuppliesHistorydatas(actSuppliesHistorydata.get(i));

            }
        }else {

            for (int i =0;i<actSuppliesHistorydata.size();i++){

                if (actSuppliesHistorydata.get(i).getIdentifyingCode()==0){

                    actSuppliesHistorydata1 = actSuppliesHistorydata.get(i);
                    actSuppliesHistorydata1.setStatus(0L);
                    actSuppliesHistorydata1.setIdentifyingCode(0L);
                    actSuppliesHistorydataMapper.insertActSuppliesHistorydata(actSuppliesHistorydata1);

                }else {
                    actSuppliesHistorydata1 = actSuppliesHistorydata.get(i);
                    actSuppliesHistorydata1.setStatus(0L);
                    actSuppliesHistorydata1.setIdentifyingCode(1L);
                    actSuppliesHistorydataMapper.insertActSuppliesHistorydata(actSuppliesHistorydata1);

                }

            }



            for (int i=0;i<actSuppliesHistorydata.size();i++){

                actSuppliesHistorydata.get(i).setCreateBy(user.getUserName());
                actSuppliesHistorydata.get(i).setCreateTime(DateUtils.getNowDate());
                actSuppliesHistorydataMapper.updateActSuppliesHistorydatas(actSuppliesHistorydata.get(i));

            }

        }

        return 0;
    }

    /**
     * 获取所有历史数据
     *
     * @return 结果
     */
    @Override
    public List<ActSuppliesHistorydata> selectActSuppliesHistorydata(Integer tylkStatus) {
        return actSuppliesHistorydataMapper.selectActSuppliesHistorydata(tylkStatus);
    }

    @Override
    public int updateActSuppliesHistorydataStatusById(Long gethId) {
        return actSuppliesHistorydataMapper.updateActSuppliesHistorydataStatusById(gethId);
    }

    /**
     * 生成表数据清洗
     *
     * @return 结果
     */
    @Override
    @Transactional
    public void addInsertImport(List<ActOperation1> actOperation2s) {
        //创建新线程
        Thread thread = new Thread(){

            public void run(){

                for (int i = 0;i<actOperation2s.size();i++) {
                    //获取生成excel表数据存储到生成表实体类中
                    for (int x = 2; x < actOperation2s.get(i).getActOperation2().length; x++) {

                        ActSuppliesSixMinesSummaryTable actSuppliesSixMinesSummaryTable = new ActSuppliesSixMinesSummaryTable();

                        UUID uuid = UUID.randomUUID();
                        String s = StringUtils.remove(uuid.toString(), '-');
                        actSuppliesSixMinesSummaryTable.setId(s);

                        actSuppliesSixMinesSummaryTable.sethId(actOperation2s.get(i).gethId());
                        if (actOperation2s.get(i).getActOperation2()[x][0].getV() != null) {
                            actSuppliesSixMinesSummaryTable.setProjectId(actOperation2s.get(i).getActOperation2()[x][0].getV());
                        } else {
                            break;
                        }

                        actSuppliesSixMinesSummaryTable.setProjectName(actOperation2s.get(i).getActOperation2()[x][1].getV());
                        actSuppliesSixMinesSummaryTable.setDepartmentName(actOperation2s.get(i).getActOperation2()[x][3].getV());

                        if (actOperation2s.get(i).getActOperation2()[x][3].getV() != null) {
                            actSuppliesSixMinesSummaryTable.setNumber(Double.valueOf(actOperation2s.get(i).getActOperation2()[x][4].getV()));
                        }
                        if (actOperation2s.get(i).getActOperation2()[x][4].getV() != null) {
                            actSuppliesSixMinesSummaryTable.setNuitPrice(Double.valueOf(actOperation2s.get(i).getActOperation2()[x][5].getV()));
                        }
                        if (actOperation2s.get(i).getActOperation2()[x][5].getV() != null) {
                            actSuppliesSixMinesSummaryTable.setMoney(Double.valueOf(actOperation2s.get(i).getActOperation2()[x][6].getV()));
                        }

                        actSuppliesSixMinesSummaryTable.setCreateBy(actOperation2s.get(i).getCreateBy());
                        actSuppliesSixMinesSummaryTable.sethDate(actOperation2s.get(i).gethDate());
                        actSuppliesSixMinesSummaryTable.setMining(actOperation2s.get(i).getMining());
                        //新增一条生成表数据
                        actSuppliesCleaningRuleMapper.addActSuppliesSixMinesSummaryTable(actSuppliesSixMinesSummaryTable);

                    }
                    //修改历史表中的数据状态（是否清洗）
                    actSuppliesHistorydataMapper.updateActSuppliesHistorydataStatusById(actOperation2s.get(i).gethId());

                }



            }

        };

        //结束线程
        thread.start();

    }

    /**
     * 导入表数据清洗
     *
     * @return 结果
     */
    @Override
    @Transactional
    public void addInsertImportss(List<ActOperation1> actOperation2s) {

        Thread thread = new Thread() {

            public void run() {

                //String[] attributes = {"A1", "A2", "A3", "A4", "A5", "A6", "A7", "A8", "A9", "A10", "A11", "A12", "A13", "A14", "A15", "A16", "A17", "A18", "A19", "A20", "A21", "A22", "A23", "A24", "A25", "A26", "A27", "A28", "A29", "A30", "A31", "A32", "A33", "A34", "A35", "A36", "A37", "A38", "A39", "A40", "A41", "A42", "A43", "A44", "A45", "A46", "A47", "A48", "A49", "A50", "A51", "A52", "A53", "A54", "A55", "A56", "A57", "A58", "A59", "A60", "A61", "A62", "A63"};

                String[] attributes = new String[200];

                for(int i=1;i<=200;i++){

                    attributes[i-1]= 'A'+String.valueOf(i);

                }

                for (int i = 0; i < actOperation2s.size(); i++) {
                    //获取导入excel表数据存储到生成表实体类中
                    for (int x = 0; x < actOperation2s.get(i).getActOperation2().length; x++) {
                        //判断数据是否为空，为空结束循环
                        if (actOperation2s.get(i).getActOperation2()[x]!=null){
                            ActSuppliesImportTable actSuppliesImportTable = new ActSuppliesImportTable();

                            UUID uuid = UUID.randomUUID();
                            String s = StringUtils.remove(uuid.toString(), '-');
                            actSuppliesImportTable.setId(s);
                            actSuppliesImportTable.sethId(actOperation2s.get(i).gethId());
                            actSuppliesImportTable.sethDate(actOperation2s.get(i).gethDate());
                            actSuppliesImportTable.setMining(actOperation2s.get(i).getMining());
                            //获取数组x行的真实非空长度
                            List<Object> actOperation2s1 = Arrays.asList(actOperation2s.get(i).getActOperation2()[x]);
                            long count = Arrays.stream(actOperation2s.get(i).getActOperation2()[x]).filter(Objects::nonNull).count();

                            //循环保存到实体类字段中
                            for (int y = 0; y < count; y++) {
                                if (actOperation2s.get(i).getActOperation2()[x][y]!=null) {
                                    if (actOperation2s.get(i).getActOperation2()[x][y].getV() != null) {
                                        try {
                                            actSuppliesImportTable.getClass().getMethod("set" + attributes[y], String.class).invoke(actSuppliesImportTable, actOperation2s.get(i).getActOperation2()[x][y].getV());
                                        } catch (Exception e) {
                                            e.printStackTrace();
                                        }

                                    }
                                }

                            }
                            //新增一条生成表数据
                            actSuppliesCleaningRuleMapper.addActSuppliesImportTable(actSuppliesImportTable);
                        }else {
                            break;
                        }

                    }
                    //修改历史表中的数据状态（是否清洗）
                    actSuppliesHistorydataMapper.updateActSuppliesHistorydataStatusById(actOperation2s.get(i).gethId());

                }

            }

        };

        thread.start();

    }


    /**
     * 通用生成表数据清洗
     *
     * @return 结果
     */
    @Override
    @Transactional
    public void addInsertConvert1(List<ActOperation1> actOperation2s) {
        Thread thread = new Thread() {

            public void run() {

                //String[] attributes = {"A1", "A2", "A3", "A4", "A5", "A6", "A7", "A8", "A9", "A10", "A11", "A12", "A13", "A14", "A15", "A16", "A17", "A18", "A19", "A20", "A21", "A22", "A23", "A24", "A25", "A26", "A27", "A28", "A29", "A30", "A31", "A32", "A33", "A34", "A35", "A36", "A37", "A38", "A39", "A40", "A41", "A42", "A43", "A44", "A45", "A46", "A47", "A48", "A49", "A50", "A51", "A52", "A53", "A54", "A55", "A56", "A57", "A58", "A59", "A60", "A61", "A62", "A63"};

                String[] attributes = new String[200];

                for(int i=1;i<=200;i++){

                    attributes[i-1]= 'A'+String.valueOf(i);

                }

                for (int i = 0; i < actOperation2s.size(); i++) {
                    //获取导入excel表数据存储到生成表实体类中
                    for (int x = 0; x < actOperation2s.get(i).getActOperation2().length; x++) {
                        //判断数据是否为空，为空结束循环
                        if (actOperation2s.get(i).getActOperation2()[x]!=null){
                            ActSuppliesImportTable actSuppliesImportTable = new ActSuppliesImportTable();

                            UUID uuid = UUID.randomUUID();
                            String s = StringUtils.remove(uuid.toString(), '-');
                            actSuppliesImportTable.setId(s);
                            actSuppliesImportTable.sethId(actOperation2s.get(i).gethId());
                            actSuppliesImportTable.sethDate(actOperation2s.get(i).gethDate());
                            actSuppliesImportTable.setMining(actOperation2s.get(i).getMining());
                            //获取数组x行的真实非空长度
                            List<Object> actOperation2s1 = Arrays.asList(actOperation2s.get(i).getActOperation2()[x]);
                            long count = Arrays.stream(actOperation2s.get(i).getActOperation2()[x]).filter(Objects::nonNull).count();

                            //循环保存到实体类字段中
                            for (int y = 0; y < count; y++) {
                                if (actOperation2s.get(i).getActOperation2()[x][y]!=null) {
                                    if (actOperation2s.get(i).getActOperation2()[x][y].getV() != null) {
                                        try {
                                            actSuppliesImportTable.getClass().getMethod("set" + attributes[y], String.class).invoke(actSuppliesImportTable, actOperation2s.get(i).getActOperation2()[x][y].getV());
                                        } catch (Exception e) {
                                            e.printStackTrace();
                                        }

                                    }
                                }

                            }
                            //新增一条生成表数据
                            actSuppliesCleaningRuleMapper.addInsertConvert1(actSuppliesImportTable);
                        }else {
                            break;
                        }

                    }
                    //修改历史表中的数据状态（是否清洗）
                    actSuppliesHistorydataMapper.updateActSuppliesHistorydataStatusById(actOperation2s.get(i).gethId());

                }

            }

        };

        thread.start();
    }

    /**
     * 通用导入表数据清洗
     *
     * @return 结果
     */
    @Override
    @Transactional
    public void addInsertConvert2(List<ActOperation1> actOperation2s) {
        Thread thread = new Thread() {

            public void run() {

                //String[] attributes = {"A1", "A2", "A3", "A4", "A5", "A6", "A7", "A8", "A9", "A10", "A11", "A12", "A13", "A14", "A15", "A16", "A17", "A18", "A19", "A20", "A21", "A22", "A23", "A24", "A25", "A26", "A27", "A28", "A29", "A30", "A31", "A32", "A33", "A34", "A35", "A36", "A37", "A38", "A39", "A40", "A41", "A42", "A43", "A44", "A45", "A46", "A47", "A48", "A49", "A50", "A51", "A52", "A53", "A54", "A55", "A56", "A57", "A58", "A59", "A60", "A61", "A62", "A63"};

                String[] attributes = new String[200];

                for(int i=1;i<=200;i++){

                    attributes[i-1]= 'A'+String.valueOf(i);

                }

                for (int i = 0; i < actOperation2s.size(); i++) {
                    //获取导入excel表数据存储到生成表实体类中
                    for (int x = 0; x < actOperation2s.get(i).getActOperation2().length; x++) {
                        //判断数据是否为空，为空结束循环
                        if (actOperation2s.get(i).getActOperation2()[x]!=null){
                            ActSuppliesImportTable actSuppliesImportTable = new ActSuppliesImportTable();

                            UUID uuid = UUID.randomUUID();
                            String s = StringUtils.remove(uuid.toString(), '-');
                            actSuppliesImportTable.setId(s);
                            actSuppliesImportTable.sethId(actOperation2s.get(i).gethId());
                            actSuppliesImportTable.sethDate(actOperation2s.get(i).gethDate());
                            actSuppliesImportTable.setMining(actOperation2s.get(i).getMining());
                            //获取数组x行的真实非空长度
                            List<Object> actOperation2s1 = Arrays.asList(actOperation2s.get(i).getActOperation2()[x]);
                            long count = Arrays.stream(actOperation2s.get(i).getActOperation2()[x]).filter(Objects::nonNull).count();

                            //循环保存到实体类字段中
                            for (int y = 0; y < count; y++) {
                                if (actOperation2s.get(i).getActOperation2()[x][y]!=null) {
                                    if (actOperation2s.get(i).getActOperation2()[x][y].getV() != null) {
                                        try {
                                            actSuppliesImportTable.getClass().getMethod("set" + attributes[y], String.class).invoke(actSuppliesImportTable, actOperation2s.get(i).getActOperation2()[x][y].getV());
                                        } catch (Exception e) {
                                            e.printStackTrace();
                                        }

                                    }
                                }

                            }
                            //新增一条生成表数据
                            actSuppliesCleaningRuleMapper.addInsertConvert2(actSuppliesImportTable);
                        }else {
                            break;
                        }

                    }
                    //修改历史表中的数据状态（是否清洗）
                    actSuppliesHistorydataMapper.updateActSuppliesHistorydataStatusById(actOperation2s.get(i).gethId());

                }

            }

        };

        thread.start();
    }

}
